uk.ac.starlink.votable

## Class ColFitsPlusTableBuilder

- java.lang.Object
- - uk.ac.starlink.votable.ColFitsPlusTableBuilder

- All Implemented Interfaces:
    TableBuilder

      public class ColFitsPlusTableBuilder
      extends java.lang.Object
      implements TableBuilder

  Implementation of the `TableBuilder` interface which reads tables stored in column-oriented FITS binary table format. The table data is stored in a BINTABLE extension which has a single row; each cell in this row contains the data for an entire column of the represented table. The primary HDU contains a byte[] array giving the table metadata as a VOTable, as for `FitsPlusTableBuilder`. If the VOTMETA card in the primary HDU does not have the value T, the VOTable metadata array is ignored.

  This rather specialised format may provide good performance for certain operations on very large, especially very wide, tables. Although it is FITS and can therefore be used in principle for data interchange, in practice most non-STIL processors are unlikely to be able to do much useful with it.

  Since:
    26 Jun 2006

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ColFitsPlusTableBuilder()` Default constructor.
    `ColFitsPlusTableBuilder(WideFits wide)` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table.
    `java.lang.String` | `getFormatName()` Returns the name of the format which can be read by this handler.
    `static boolean` | `isMagic(byte[] buffer)`
    `boolean` | `looksLikeFile(java.lang.String location)` Indicates whether the given location string is of a familiar form for this builder.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy policy)` Constructs a `StarTable` based on a given `DataSource`.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Reads a table from an input stream and writes it a row at a time to a sink.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ColFitsPlusTableBuilder

          public ColFitsPlusTableBuilder()

      Default constructor.

    - #### ColFitsPlusTableBuilder

          public ColFitsPlusTableBuilder(WideFits wide)

      Constructor.
      Parameters:
        `wide` - convention for representing extended columns; use null to avoid use of extended columns

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Description copied from interface: `TableBuilder`
      Returns the name of the format which can be read by this handler. Matching against this string may be used by callers to identify or select this handler from a list.
      Specified by:
        `getFormatName` in interface `TableBuilder`
      Returns:
        one-word description of this handler's format

    - #### looksLikeFile

          public boolean looksLikeFile(java.lang.String location)

      Description copied from interface: `TableBuilder`
      Indicates whether the given location string is of a familiar form for this builder. Implementations should return `true` if there is a good chance that a file with the given `location` can be interpreted by this reader, for instance if it has a suitable file extension.

      This method may be used to guess, on a best-efforts basis, whether this builder is suitable for reading a file from a given location. Attempts may still be made to read inputs for which this method returns false. It is less important for builders that can recognise files by magic number, which is generally preferable to using filenames.

      Specified by:
        `looksLikeFile` in interface `TableBuilder`
      Parameters:
        `location` - the location string, such as a filename or URL (not null)
      Returns:
        true iff there is a good chance that the named input can be interpreted by this reader

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws TableFormatException

      Description copied from interface: `TableBuilder`
      Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

      The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

      Specified by:
        `streamStarTable` in interface `TableBuilder`
      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Description copied from interface: `TableBuilder`
      Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table. It should return `true` if it thinks that its `TableBuilder.streamStarTable(java.io.InputStream, uk.ac.starlink.table.TableSink, java.lang.String)` method stands a reasonable chance of successfully constructing a `StarTable` from a `DataSource` whose input stream is described by the `DataFlavor` `flavor`. It will typically make this determination based on the flavor's MIME type.

      This method should only return `true` if the flavor looks like it is targeted at this builder; for instance a builder which uses a text-based format should return false for a flavor which indicates a MIME type of `text/plain`.

      This method is used in supporting drag and drop functionality (see `StarTableFactory.canImport(java.awt.datatransfer.DataFlavor[])`).

      Specified by:
        `canImport` in interface `TableBuilder`
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy policy)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Specified by:
        `makeStarTable` in interface `TableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `policy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### isMagic

          public static boolean isMagic(byte[] buffer)